/*
 * Created on 16.08.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package analysisOperations;

import gui.Option;
import ij.measure.ResultsTable;
import operations.Operation;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class FilterLongObjectsOperation extends Operation {

	/**
	 * 
	 */
	private static final long serialVersionUID = -4636314007082067134L;
	protected ResultsTable measurements;
	protected ResultsTable resultMeasurements;
	protected Option minSize;
	protected Option minCircularity;
	protected Option minSizeHeightFactor;

	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.measure.ResultsTable");
		parameterNames = new String[1];
		parameterNames[0] = "Measurements";
		optionsNames = new String[3];
		optionsNames[0] = "min size";
		optionsNames[1] = "min circularity";
		optionsNames[2] = "min size-height factor";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("ij.measure.ResultsTable");
		resultNames = new String[1];
		resultNames[0] = "ResultMeasurements";
	}
	/**
	 * @return Returns the measurements.
	 */
	public ResultsTable getMeasurements() {
		return measurements;
	}
	/**
	 * @param measurements The measurements to set.
	 */
	public void setMeasurements(ResultsTable measurements) {
		this.measurements = measurements;
	}
	/**
	 * @return Returns the resultMeasurements.
	 */
	public ResultsTable getResultMeasurements() {
		return resultMeasurements;
	}
	/**
	 * @param resultMeasurements The resultMeasurements to set.
	 */
	public void setResultMeasurements(ResultsTable resultMeasurements) {
		this.resultMeasurements = resultMeasurements;
	}
	/**
	 * @return Returns the minCircularity.
	 */
	public float getMinCircularity() {
		return minCircularity.getFloatValue();
	}
	/**
	 * @param minCircularity The minCircularity to set.
	 */
	public void setMinCircularity(float minCircularity) {
		this.minCircularity.setValue(new Float(minCircularity).toString());
	}
	/**
	 * @return Returns the minSize.
	 */
	public float getMinSize() {
		return minSize.getFloatValue();
	}
	/**
	 * @param minSize The minSize to set.
	 */
	public void setMinSize(float minSize) {
		this.minSize.setValue(new Float(minSize).toString());
	}
	/**
	 * @return Returns the minSizeHeightFactor.
	 */
	public float getMinSizeHeightFactor() {
		return minSizeHeightFactor.getFloatValue();
	}
	/**
	 * @param minSizeHeightFactor The minSizeHeightFactor to set.
	 */
	public void setMinSizeHeightFactor(float minSizeHeightFactor) {
		this.minSizeHeightFactor.setValue(new Float(minSizeHeightFactor).toString());
	}
	
	protected void setupOptions() {
		super.setupOptions();
		this.setMinSize(10);
		this.setMinCircularity(0.3f);
		this.setMinSizeHeightFactor(1.5f);
	}
	
	public void connectOptions() {
		this.minSize= (Option) this.options.getOptions().elementAt(0);
		this.minCircularity = (Option) this.options.getOptions().elementAt(1);
		this.minSizeHeightFactor = (Option) this.options.getOptions().elementAt(2);
	}
	
	/**
	 * 
	 */
	protected void cleanUpInput() {
		this.setMeasurements(null);
	}

	/**
	 * 
	 */
	protected void showResult() {
		this.getResultMeasurements().show("objects");
	}
	
	/**
	 *  
	 */
	public void doIt() {
		resultMeasurements = new ResultsTable();
		resultMeasurements.reset();
		ResultsTable measurements = this.getMeasurements();
		for (int i=0; i<measurements.getCounter(); i++) {
			float xSize = measurements.getValue(ResultsTable.ROI_WIDTH, i);
			float circularity = measurements.getValue(ResultsTable.CIRCULARITY, i);
			float ySize = measurements.getValue(ResultsTable.ROI_HEIGHT, i);
			if (xSize<this.getMinSize()) continue;
			if (circularity>this.getMinCircularity()) continue;
			if (ySize*this.getMinSizeHeightFactor()>xSize) continue;
			resultMeasurements.incrementCounter();
			resultMeasurements.addValue(ResultsTable.X_CENTROID, measurements.getValue(ResultsTable.X_CENTROID, i));
			resultMeasurements.addValue(ResultsTable.Y_CENTROID, measurements.getValue(ResultsTable.Y_CENTROID, i));
		}
	}
}
