/*
 * Created on 04.11.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package analysisOperations;

import ij.ImagePlus;
import ij.measure.ResultsTable;
import gui.BooleanOption;
import gui.Option;
import gui.Options;
import operations.Operation;
import particleAnalysis.threeDimensional.MRI_3D_objects_counter;


/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Find3dObjectsOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = -6430665132043143941L;
	
	protected Option minSize;
	protected Option maxSize;
	protected BooleanOption displayLabels;
	protected BooleanOption computeOutlines;
	
	ResultsTable measurements;
	ImagePlus mask;
	ImagePlus outlines;
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		optionsNames = new String[4];
		optionsNames[0] = "min size";
		optionsNames[1] = "max size";
		optionsNames[2] = "display labels";
		optionsNames[3] = "compute outlines";
		resultTypes = new Class[3];
		resultTypes[0] = Class.forName("ij.measure.ResultsTable");
		resultTypes[1] = Class.forName("ij.ImagePlus");
		resultTypes[2] = Class.forName("ij.ImagePlus");
		resultNames = new String[3];
		resultNames[0] = "Measurements";
		resultNames[1] = "Mask";
		resultNames[2] = "Outlines";
	}
	
	/**
	 * @return Returns the mask.
	 */
	public ImagePlus getMask() {
		return mask;
	}
	/**
	 * @param mask The mask to set.
	 */
	public void setMask(ImagePlus mask) {
		this.mask = mask;
	}
	/**
	 * @return Returns the maxSize.
	 */
	public int getMaxSize() {
		return maxSize.getIntegerValue();
	}
	/**
	 * @param maxSize The maxSize to set.
	 */
	public void setMaxSize(int maxSize) {
		this.maxSize.setValue(Integer.toString(maxSize));
	}
	/**
	 * @return Returns the measurements.
	 */
	public ResultsTable getMeasurements() {
		if (measurements==null) {
			measurements = new ResultsTable();
		}
		return measurements;
	}
	/**
	 * @param measurements The measurements to set.
	 */
	public void setMeasurements(ResultsTable measurements) {
		this.measurements = measurements;
	}
	/**
	 * @return Returns the minSize.
	 */
	public int getMinSize() {
		return minSize.getIntegerValue();
	}
	/**
	 * @param minSize The minSize to set.
	 */
	public void setMinSize(int minSize) {
		this.minSize.setValue(Integer.toString(minSize));
	}
	/**
	 * @return Returns the outlines.
	 */
	public ImagePlus getOutlines() {
		return outlines;
	}
	/**
	 * @param outlines The outlines to set.
	 */
	public void setOutlines(ImagePlus outlines) {
		this.outlines = outlines;
	}
	
	public void doIt() {
		ResultsTable measurements = this.getMeasurements();
		measurements.reset();
		MRI_3D_objects_counter counter = new MRI_3D_objects_counter(this.getInputImage(), 
																  this.getMinSize(), 
																  this.getMaxSize(), 
																  this.getDisplayLabels());
		counter.run("");
		this.setMeasurements(counter.getMeasurements());
		this.setMask(counter.getParticles());
		this.setOutlines(counter.getEdges());
	}
	
	protected void setupOptions() {
		options = new Options(); 
		options.setName(this.name() + " options");
		String[] optionsNames = this.getOptionsNames();
		// min 
		this.minSize = new Option();
		this.setMinSize(10);
		minSize.setName(optionsNames[0]);
		options.add(this.minSize);
		// max
		this.maxSize = new Option();
		maxSize.setName(optionsNames[1]);
		this.setMaxSize(999999);
		options.add(this.maxSize);
		// display labels
		this.displayLabels = new BooleanOption();
		this.setDisplayLabels(false);
		displayLabels.setName(optionsNames[2]);
		options.add(this.displayLabels);
		// compute outlines
		this.computeOutlines = new BooleanOption();
		this.setComputeOutlines(false);
		computeOutlines.setName(optionsNames[3]);
		options.add(this.computeOutlines);
	}

	public void connectOptions() {
		this.minSize = (Option) this.options.getOptions().elementAt(0);
		this.maxSize = (Option) this.options.getOptions().elementAt(1);
		this.displayLabels = (BooleanOption) this.options.getOptions().elementAt(2);
		this.computeOutlines = (BooleanOption) this.options.getOptions().elementAt(2);
	}
	/**
	 * @return Returns the displayLabels.
	 */
	public boolean getDisplayLabels() {
		return displayLabels.getBooleanValue();
	}
	/**
	 * @param displayLabels The displayLabels to set.
	 */
	public void setDisplayLabels(boolean showNumbers) {
		this.displayLabels.setValue(Boolean.toString(showNumbers));
	}
	/**
	 * @return Returns the computeOutlines.
	 */
	public boolean getComputeOutlines() {
		return computeOutlines.getBooleanValue();
	}
	/**
	 * @param computeOutlines The computeOutlines to set.
	 */
	public void setComputeOutlines(boolean computeOutlines) {
		this.computeOutlines.setValue(Boolean.toString(computeOutlines));
	}
}
