package analysisOperations;

import ij.IJ;
import ij.ImagePlus;
import ij.WindowManager;
import ij.measure.ResultsTable;
import imagejProxies.SilentParticleAnalyzer;

public class FindObjectsRedirectingOperation extends FindObjectsOperation {
	ImagePlus redirectToImage;
	/**
	 * 
	 */
	private static final long serialVersionUID = -528219103340383733L;
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[2];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterTypes[1] = Class.forName("ij.ImagePlus");
		parameterNames = new String[2];
		parameterNames[0] = "InputImage";
		parameterNames[1] = "RedirectToImage";
	}

	public ImagePlus getRedirectToImage() {
		return redirectToImage;
	}

	public void setRedirectToImage(ImagePlus redirectToImage) {
		this.redirectToImage = redirectToImage;
	}
	
	public void doIt() {
		ResultsTable measurements = this.getMeasurements();
		measurements.reset();
		SilentParticleAnalyzer analyzer = new SilentParticleAnalyzer(this.getOptionsWord(), 
				this.getMeasurementsWord(), 
				measurements,
				this.getMinSize(),
				this.getMaxSize());
		int oldIndex = analyzer.getRedirectTarget();
		String oldTitle = analyzer.getRedirectTitle();
		this.getRedirectToImage().setTitle("redirect to image");
		this.getRedirectToImage().show();
		int[] ids = WindowManager.getIDList();
		int id = ids[ids.length-1];
		analyzer.setRedirectTarget(id);
		analyzer.setRedirectTitle("redirect to image");
		int previousShowChoice = SilentParticleAnalyzer.getShowChoice();
		SilentParticleAnalyzer.setShowChoice(2);
		analyzer.analyze(this.getInputImage(), this.getInputImage().getProcessor());
		IJ.showStatus(measurements.getCounter() + " objects found");
		mask = analyzer.getOutlineImage();
		SilentParticleAnalyzer.setShowChoice(previousShowChoice);
		this.computeOutlines();
		this.getRedirectToImage().hide();
		analyzer.setRedirectTarget(oldIndex);
		analyzer.setRedirectTitle(oldTitle);
		
	}
	
	
	protected void cleanUpInput() {
		super.cleanUpInput();
		this.setRedirectToImage(null);	
	}
}
