package cellCounter;

import gui.ListEditor;
import gui.MultiChannelListEditor;

import java.util.Iterator;
import java.util.Observable;
import java.util.Vector;

public class CellCounter extends Observable {
	protected CellCounterView view;
	protected Vector channels;
	protected MultiChannelListEditor editor;
	int numberOfChannels;
	
	public void show() {
		this.getView().setVisible(true);
	}

	public CellCounterView getView() {
		if (view==null) view = new CellCounterView(this);
		return view;
	}

	public void handleListEditorClosed() {
		channels = editor.getChannels();
		Iterator it = channels.iterator();
		numberOfChannels = 0;
		while(it.hasNext()) {
			ListEditor channel = (ListEditor) it.next();
			if (!channel.getList().isEmpty()) {
				numberOfChannels++;
			}
		}
	}

	public void setEditor(MultiChannelListEditor editor) {
		this.editor = editor;
	}

	public int getNumberOfChannels() {
		return numberOfChannels;
	}
}
