/*
 * Created on 26.08.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package controlOperations;

import gui.BooleanOption;
import gui.ListEditor;
import gui.ListOption;
import gui.Option;
import gui.Options;

import ij.IJ;

import java.io.File;
import java.util.Vector;

import operations.Operation;

/**
 * @author Volker
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class ForeachImageDoOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = -1848902732538247334L;
	protected Option imageList;
	protected Option useSequenceOpener;
	
	protected String currentFilename;

	protected int currentIndex = 0;

	protected Boolean atEnd = new Boolean(false);

	protected boolean imageListWasEmpty;
	
	public ForeachImageDoOperation() {
		super();
		imageListWasEmpty = false;
	}

	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[0];
		parameterNames = new String[0];
		optionsNames = new String[2];
		optionsNames[0] = "image list";
		optionsNames[1] = "use sequence opener";
		resultTypes = new Class[3];
		resultTypes[0] = Class.forName("java.lang.String");
		resultTypes[1] = Class.forName("java.lang.Boolean");
		resultTypes[2] = Class.forName("controlOperations.ForeachImageDoOperation");
		resultNames = new String[3];
		resultNames[0] = "CurrentFilename";
		resultNames[1] = "AtEnd";
		resultNames[2] = "DoOperation";
	}

	public ForeachImageDoOperation getDoOperation() {
		return this;
	}

	public void setDoOperation(ForeachImageDoOperation op) {
	}

		
	/**
	 * @return Returns the currentFilename.
	 */
	public String getCurrentFilename() {
		return currentFilename;
	}

	/**
	 * @param currentFilename
	 *            The currentFilename to set.
	 */
	public void setCurrentFilename(String currentFilename) {
		this.currentFilename = currentFilename;
	}

	/**
	 * @return Returns the imageList.
	 */
	public Vector getImageList() {
		return imageList.getListValue();
	}

	protected void setupOptions() {
		options = new Options();
		options.setName(this.name() + " options");
		String[] optionsNames = this.getOptionsNames();
		this.imageList = new ListOption();
		imageList.setName(optionsNames[0]);
		imageList.setShortHelpText("press edit to select images or a folder");
		options.add(this.imageList);
		this.useSequenceOpener = new BooleanOption();
		useSequenceOpener.setName(optionsNames[1]);
		useSequenceOpener.setShortHelpText("check to use the sequence opener instead of the file dialog.");
		options.add(useSequenceOpener);
	}

	public void doIt() {
		this.getApplication().cleanupResultsAfter(this);
		if (this.getImageList().size()==0) {
			ListEditor editor = ((ListOption)this.imageList).getEditor();
			if (this.getUseSequenceOpener()) {
				editor.setUseSequenceOpener(true);
			}
			editor.view().getAddButton().doClick();
			imageListWasEmpty = true;
		}
		if (this.getImageList().size()==0) {
			this.setAtEnd(new Boolean(true));
			this.stopApplication();
			return;
		}
		String message = "Iteration " + (currentIndex+1) + "/" + this.getImageList().size();
		IJ.showStatus(message);
		this.setCurrentFilename(((File)this.getImageList().elementAt(this.currentIndex)).getAbsolutePath());
		if (currentIndex==this.getImageList().size()-1) {
			this.setAtEnd(new Boolean(true));
		}
	}

	public boolean next() {
		if (this.getAtEnd().booleanValue()) return false;
		currentIndex++;
		return true;
	}
	
	public void connectOptions() {
		this.imageList = (ListOption) this.options.getOptions().elementAt(0);
		this.useSequenceOpener = (BooleanOption) this.options.getOptions().elementAt(1);
	}

	public void reset() {
		this.setAtEnd(new Boolean(false));
		this.currentIndex = 0;
		if (imageListWasEmpty) {
			((ListOption)this.imageList).getEditor().getList().removeAllElements();
		}
	}
	/**
	 * @return Returns the atEnd.
	 */
	public Boolean getAtEnd() {
		if (atEnd==null) {
			atEnd = new Boolean(false);
		}
		return atEnd;
	}

	/**
	 * @param atEnd
	 *            The atEnd to set.
	 */
	public void setAtEnd(Boolean atEnd) {
		this.atEnd = atEnd;
	}
	
	/**
	 * @return
	 */
	public boolean isLoop() {
		return true;
	}
	/**
	 * @return Returns the imageListWasEmpty.
	 */
	public boolean isImageListWasEmpty() {
		return imageListWasEmpty;
	}
	/**
	 * @param imageListWasEmpty The imageListWasEmpty to set.
	 */
	public void setImageListWasEmpty(boolean imageListWasEmpty) {
		this.imageListWasEmpty = imageListWasEmpty;
	}
	
	public void resetPathOptions() {
		imageListWasEmpty = true;
		this.reset();
	}
	
	public void setPathOptionsFromUser() {
		ListEditor editor = ((ListOption)this.imageList).getEditor();
		if (this.getUseSequenceOpener()) {
			editor.setUseSequenceOpener(true);
		}
		editor.view().getAddButton().doClick();
		imageListWasEmpty = false;
		if (this.getImageList().size()==0) {
			this.stopApplication();
		}
	}
	/**
	 * @return Returns the currentIndex.
	 */
	public int getCurrentIndex() {
		return currentIndex;
	}
	/**
	 * @return Returns the useSequenceOpener.
	 */
	public boolean getUseSequenceOpener() {
		return useSequenceOpener.getBooleanValue();
	}
	/**
	 * @param useSequenceOpener The useSequenceOpener to set.
	 */
	public void setUseSequenceOpener(boolean value) {
		this.useSequenceOpener.setValue(Boolean.toString(value));
	}
}