package controlOperations;

import gui.ListEditor;
import gui.ListOption;
import ij.IJ;

import java.io.File;

public class ForeachImageInListDoOperation extends ForeachImageDoOperation {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 711957037748122577L;

		
	public void doIt() {
		this.getApplication().cleanupResultsAfter(this);
		if (this.getImageList().size()==0) {
			ListEditor editor = ((ListOption)this.imageList).getEditor();
			if (this.getUseSequenceOpener()) {
				editor.setUseSequenceOpener(true);
			}
			editor.show();
			imageListWasEmpty = true;
		}
		if (this.getImageList().size()==0) {
			this.setAtEnd(new Boolean(true));
			this.stopApplication();
			return;
		}
		String message = "Iteration " + (currentIndex+1) + "/" + this.getImageList().size();
		IJ.showStatus(message);
		this.setCurrentFilename(((File)this.getImageList().elementAt(this.currentIndex)).getAbsolutePath());
		if (currentIndex==this.getImageList().size()-1) {
			this.setAtEnd(new Boolean(true));
		}
	}
	
	public void setPathOptionsFromUser() {
		ListEditor editor = ((ListOption)this.imageList).getEditor();
		if (this.getUseSequenceOpener()) {
			editor.setUseSequenceOpener(true);
		}
		editor.show();
		while (editor.view().isVisible()) {
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			Thread.yield();
		}
		imageListWasEmpty = false;
		if (this.getImageList().size()==0) {
			this.stopApplication();
		}
	}
}
