/*
 * Created on 05.07.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gui;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Vector;
import java.util.Iterator;
import javax.swing.JButton;
import javax.swing.SwingUtilities;
import operations.Operation;
import operations.OperationView;


/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class OperationsBox {

	protected String title;
	protected Vector operations;
	protected OperationsBoxView view;
	static protected Vector openOperationsBoxViews = new Vector();
	private String path;
	
	/**
	 * Default Constructor. Initializes the application.
	 *
	 */
	public OperationsBox() {
		this.initialize();
	}
	
	/**
	 * 
	 */
	private void initialize() {
		operations = new Vector();
		view = new OperationsBoxView();
		view.setModel(this);
	}

	/**
	 * @param string
	 */
	public void setTitle(String string) {
		title = string;
	}

	/**
	 * @return Returns the title.
	 */
	public String getTitle() {
		return title;
	}

	/**
	 * @param operation
	 */
	public void add(Operation operation) {
		operations.add(operation);
	}
	
	public void show() {
		view.setTitle(this.getTitle());
		double xSize = 0;
		double ySize = 0;
		int maxButtonWidth = 0;
		int buttonWidth;
		for (int i=0; i<operations.size(); i++) {
			Operation operation = (Operation) operations.elementAt(i);
			this.view.getJPanel().add(operation.view().getJPanel());
		}
		for (int i=0; i<operations.size(); i++) {
			Operation anOperation = (Operation) operations.elementAt(i);
			OperationView view = anOperation.view();
			buttonWidth = view.getJButton1().getText().length();
			if (buttonWidth > maxButtonWidth) maxButtonWidth = buttonWidth;
			if (view.getSize().getWidth()>xSize) xSize = view.getSize().getWidth();
			ySize += view.getSize().getHeight()+1;
		}
		for (int i=0; i<operations.size(); i++) {
			Operation anOperation = (Operation) operations.elementAt(i);
			OperationView view = anOperation.view();
			JButton button = view.getJButton1(); 
			String text = button.getText();
			if (text.length()<maxButtonWidth) {
				while(text.length()<maxButtonWidth) {
					text += " ";
				}
			}
			button.setText(text);
		}
		this.view.setSize((int)xSize+16, Math.min((int)ySize, 600));
		this.view.setVisible(true);
		openOperationsBoxViews.add(view);
	}

	/**
	 * @param view2
	 */
	public void operationsBoxViewClosed(OperationsBoxView aView) {
		openOperationsBoxViews.remove(aView);
	}

	/**
	 * @param view2
	 */
	public void moveToFront(OperationsBoxView aView) {
		openOperationsBoxViews.remove(view);
		openOperationsBoxViews.insertElementAt(aView,0);
	}
	/**
	 * @return Returns the openOperationsBoxViews.
	 */
	public static Vector getOpenOperationsBoxViews() {
		return openOperationsBoxViews;
	}

	/**
	 * @param model
	 * @param e
	 */
	public static void checkForDropAction(Operation operation, MouseEvent e) {
		Iterator it = openOperationsBoxViews.iterator();
		while (it.hasNext()) {
			OperationsBoxView boxView = (OperationsBoxView)it.next();
			if (boxView.getState()!=OperationsBoxView.NORMAL || !boxView.isVisible()) continue;
			Rectangle viewBounds = boxView.getBounds();
			Point point = e.getPoint(); 
			SwingUtilities.convertPointToScreen(point,
					e.getComponent());
			if (viewBounds.contains(point)) {
				Point localPoint = SwingUtilities.convertPoint(e.getComponent(), e.getPoint(), boxView.getJPanel());
				boxView.operationDropedAt(operation, localPoint);
				break;
			}
		}
		
		
	}
	/**
	 * @return Returns the operations.
	 */
	public Vector getOperations() {
		return operations;
	}

	/**
	 * @param operation
	 * @param addAfterIndex
	 */
	public void addOperationAfterIndex(Operation operation, int addAfterIndex) {
		this.getOperations().add(addAfterIndex+1, operation);
		operation.view().dispose();
		this.rebuildViews();
	}

	/**
	 * 
	 */
	private void rebuildViews() {
		Rectangle bounds = this.getView().getBounds();
		this.getView().dispose();
		this.show();
		this.getView().setBounds(bounds);
		this.view.validate();
	}
	/**
	 * @return Returns the view.
	 */
	public OperationsBoxView getView() {
		return view;
	}

	/**
	 * @return
	 */
	public static String fileExtension() {
		return ".cio";
	}

	/**
	 * @param absolutePath
	 * @throws IOException
	 */
	public void save(String path) throws IOException {
		FileWriter fileWriter;
		BufferedWriter out = null;
		try {
			fileWriter = new FileWriter(path);
			out = new BufferedWriter(fileWriter);
			this.printOn(out);
			this.setupPathAndTitle(path);
		} catch (IOException e) {
			if (out!=null) {
				try {
					out.close();
				} catch (IOException e1) {
					// ignore
				}
			}
			throw e;
		} finally {
			if (out!=null) {
				try {
					out.close();
				} catch (IOException e1) {
					// ignore
				}
			}
		}
		CellImageAnalyzer app = CellImageAnalyzer.getCurrent();
		app.rebuildOperationMenu();
	}
	
	public static OperationsBox load(String path) {
		FileReader fileReader;
		BufferedReader in = null;
		OperationsBox box = null;
		try {
			fileReader = new FileReader(path);
			in = new BufferedReader(fileReader);
			box = (OperationsBox) OperationsBox.readFrom(in);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			if (in!=null) {
				try {
					in.close();
				} catch (IOException e1) {
					// ignore
				}
			}
		}
		box.setupPathAndTitle(path);
		return box;
	}
	
	/**
	 * @param path
	 * @param box
	 */
	private void setupPathAndTitle(String path) {
		this.setPath(path);
		File aFile = new File(path);
		String name = aFile.getName();
		name = name.substring(0, name.length()-4);
		this.setTitle(name);
	}

	/**
	 * @param in
	 * @return
	 * @throws IOException
	 */
	private static OperationsBox readFrom(BufferedReader in) throws IOException {
		OperationsBox box = new OperationsBox();
		Operation op;
		try {
			while((op = (Operation)Operation.readFrom(in))!=null) {
				box.add(op);
				op.setShowResult(true);
			}
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			box = null;
			throw e;
		}
		return box;
	}

	/**
	 * @param out
	 * @throws IOException
	 */
	private void printOn(BufferedWriter out) throws IOException {
		Iterator it = operations.iterator();
		while(it.hasNext()) {
			Operation anOperation = (Operation) it.next();
			anOperation.printOn(out);
		}
	}
	
	
	/**
	 * @return Returns the path.
	 */
	public String getPath() {
		if (path==null) {
			File file = new File("." + File.separator + baseFolder() + File.separator + this.getTitle());
			path = file.getAbsolutePath() + fileExtension();
		}
		return path;
	}

	/**
	 * @return
	 */
	public static String baseFolder() {
		return "_operations";
	}

	
	/**
	 * @param path The path to set.
	 */
	public void setPath(String path) {
		this.path = path;
	}

	/**
	 * @param operation
	 */
	public void removeOperation(Operation operation) {
		operations.remove(operation);
	}
}
