/*
 * Created on 09.11.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package imageJPlugins;

import java.awt.Label;
import java.awt.TextField;
import java.awt.event.ItemEvent;
import java.awt.event.TextEvent;

import ij.IJ;
import ij.ImagePlus;
import ij.gui.GenericDialog;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class VirtualOpenerDialog  extends GenericDialog {
	 ImagePlus imp;
	    int fileCount;
	    boolean eightBits;
	    String saveFilter = "";
	    String[] list;

	    public VirtualOpenerDialog(String title, ImagePlus imp, String[] list) {
	        super(title);
	        this.imp = imp;
	        this.list = list;
	        this.fileCount = list.length;
	    }

	    protected void setup() {
	        setStackInfo();
	    }
	    
	    public void itemStateChanged(ItemEvent e) {
	        setStackInfo();
	    }
	    
	    public void textValueChanged(TextEvent e) {
	        setStackInfo();
	    }

	    void setStackInfo() {
	        int width = imp.getWidth();
	        int height = imp.getHeight();
	        int bytesPerPixel = 1;
	        int n = getNumber(numberField.elementAt(0));
	        int start = getNumber(numberField.elementAt(1));
	        int inc = getNumber(numberField.elementAt(2));
	         
	        if (n<1)
	            n = fileCount;
	        if (start<1 || start>fileCount)
	            start = 1;
	        if (start+n-1>fileCount)
	            n = fileCount-start+1;
	        if (inc<1)
	            inc = 1;
	        TextField tf = (TextField)stringField.elementAt(0);
	        String filter = tf.getText();
	        // IJ.write(nImages+" "+startingImage);
	        if (!filter.equals("") && !filter.equals("*")) {
	            int n2 = n;
	            n = 0;
	            for (int i=start-1; i<start-1+n2; i++)
	                if (list[i].indexOf(filter)>=0) {
	                    n++;
	                    //IJ.write(n+" "+list[i]);
	                }
	            saveFilter = filter;
	        }
	        switch (imp.getType()) {
	            case ImagePlus.GRAY16:
	                bytesPerPixel=2;break;
	            case ImagePlus.COLOR_RGB:
	            case ImagePlus.GRAY32:
	                bytesPerPixel=4; break;
	        }
	        if (eightBits)
	            bytesPerPixel = 1;
	        int n2 = n/inc;
	        if (n2<0)
	            n2 = 0;
	        double size = ((double)width*height*n2*bytesPerPixel)/(1024*1024);
	        ((Label)theLabel).setText(width+" x "+height+" x "+n2+" ("+IJ.d2s(size,1)+"MB)");
	    }

	    public int getNumber(Object field) {
	        TextField tf = (TextField)field;
	        String theText = tf.getText();
	        double value;
	        Double d;
	        try {d = new Double(theText);}
	        catch (NumberFormatException e){
	            d = null;
	        }
	        if (d!=null)
	            return (int)d.doubleValue();
	        else
	            return 0;
	      }

}
