/*
 * Created on 09.11.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package imageJPlugins;

import java.awt.image.ColorModel;
import java.io.File;

import javax.swing.JFileChooser;
import ij.IJ;
import ij.ImagePlus;
import ij.Macro;
import ij.io.FileInfo;
import ij.io.OpenDialog;
import ij.io.Opener;
import ij.plugin.PlugIn;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Virtual_Stack_Opener implements PlugIn {
	 private static boolean grayscale;
	    private static double scale = 100.0;
	    private int n, start, increment;
	    private String filter;
	    private FileInfo fi;
	    private String info1;

	    public void run(String arg) {
	        JFileChooser fileChooser = new JFileChooser();
			if (OpenDialog.getDefaultDirectory()!=null) {
				fileChooser.setCurrentDirectory(new File(OpenDialog.getDefaultDirectory()));
			}
			fileChooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
			fileChooser.setMultiSelectionEnabled(false);
			int returnVal = fileChooser.showOpenDialog(null);
			if (returnVal != JFileChooser.APPROVE_OPTION) return;
			File newFolder = fileChooser.getSelectedFile();
			if (!newFolder.isDirectory()) {
				newFolder = fileChooser.getCurrentDirectory();
			}
			String directory = newFolder.getAbsolutePath();
			
	        if (directory==null)
	            return;
	        Macro.setOptions(null); // Prevents later use of OpenDialog from reopening the same file

	        String[] list = new File(directory).list();
	        if (list==null)
	            return;
	        IJ.register(Virtual_Stack_Opener.class);
	        ij.util.StringSorter.sort(list);
	        if (IJ.debugMode) IJ.log("FolderOpener: "+directory+" ("+list.length+" files)");
	        int width=0,height=0,type=0;
	        VirtualStack stack = null;
	        double min = Double.MAX_VALUE;
	        double max = -Double.MAX_VALUE;
	        
	        try {
	            for (int i=0; i<list.length; i++) {
	                if (list[i].endsWith(".txt"))
	                    continue;
	                ImagePlus imp = new Opener().openImage(directory, list[i]);
	                if (imp!=null) {
	                    width = imp.getWidth();
	                    height = imp.getHeight();
	                    type = imp.getType();
	                    fi = imp.getOriginalFileInfo();
	                    if (!showDialog(imp, list))
	                        return;
	                    break;
	                }
	            }
	            if (width==0) {
	                IJ.showMessage("Import Sequence", "This folder does not appear to contain any TIFF,\n"
	                + "JPEG, BMP, DICOM, GIF, FITS or PGM files.");
	                return;
	            }

	            if (n<1)
	                n = list.length;
	            if (start<1 || start>list.length)
	                start = 1;
	            if (start+n-1>list.length)
	                n = list.length-start+1;
	            int filteredImages = n;
	            if (filter!=null && (filter.equals("") || filter.equals("*")))
	                filter = null;
	            if (filter!=null) {
	                filteredImages = 0;
	                for (int i=start-1; i<start-1+n; i++) {
	                    if (list[i].indexOf(filter)>=0)
	                        filteredImages++;
	                }
	                if (filteredImages==0) {
	                    IJ.error("None of the "+n+" files contain\n the string '"+filter+"' in their name.");
	                    return;
	                }
	            }
	            n = filteredImages;
	            
	            int count = 0;
	            int counter = 0;
	            ImagePlus imp = null;
	            for (int i=start-1; i<list.length; i++) {
	               if (list[i].endsWith(".txt"))
	                    continue;
	                if (filter!=null && (list[i].indexOf(filter)<0))
	                    continue;
	                if ((counter++%increment)!=0)
	                    continue;
	                if (stack==null)
	                    imp = new Opener().openImage(directory, list[i]);
	                if (imp==null) continue;
	                if (stack==null) {
	                    width = imp.getWidth();
	                    height = imp.getHeight();
	                    type = imp.getType();
	                    ColorModel cm = imp.getProcessor().getColorModel();
	                    stack = new VirtualStack(width, height, cm, directory);
	                 }
	                count = stack.getSize()+1;
	                IJ.showStatus(count+"/"+n);
	                IJ.showProgress((double)count/n);
	                stack.addSlice(list[i]);
	                if (count>=n)
	                    break;
	            }
	        } catch(OutOfMemoryError e) {
	            IJ.outOfMemory("FolderOpener");
	            if (stack!=null) stack.trim();
	        }
	        if (stack!=null && stack.getSize()>0) {
	            ImagePlus imp2 = new ImagePlus("Stack", stack);
	            if (imp2.getType()==ImagePlus.GRAY16 || imp2.getType()==ImagePlus.GRAY32)
	                imp2.getProcessor().setMinAndMax(min, max);
	            imp2.setFileInfo(fi); // saves FileInfo of the first image
	            if (imp2.getStackSize()==1 && info1!=null)
	                imp2.setProperty("Info", info1);
	            imp2.show();
	        }
	        IJ.showProgress(1.0);
	    }
	    
	    boolean showDialog(ImagePlus imp, String[] list) {
	        int fileCount = list.length;
	        VirtualOpenerDialog gd = new VirtualOpenerDialog("Sequence Options", imp, list);
	        gd.addNumericField("Number of Images:", fileCount, 0);
	        gd.addNumericField("Starting Image:", 1, 0);
	        gd.addNumericField("Increment:", 1, 0);
	        gd.addStringField("File Name Contains:", "");
	        gd.addMessage("10000 x 10000 x 1000 (100.3MB)");
	        gd.showDialog();
	        if (gd.wasCanceled())
	            return false;
	        n = (int)gd.getNextNumber();
	        start = (int)gd.getNextNumber();
	        increment = (int)gd.getNextNumber();
	        if (increment<1)
	            increment = 1;
	        filter = gd.getNextString();
	        return true;
	    }

}
