/*
 * Created on 19.07.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package processingOperations;

import gui.BooleanOption;
import gui.MatrixOption;
import gui.Options;
import ij.ImagePlus;
import ij.ImageStack;
import ij.plugin.filter.Convolver;
import ij.process.ImageProcessor;
import operations.Operation;


/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ConvolveOperation extends Operation {
	
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -484925125891190161L;
	MatrixOption kernel;
	BooleanOption normalize;
	private Convolver convolver;
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		optionsNames = new String[2];
		optionsNames[0] = "kernel";
		optionsNames[1] = "normalize";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultNames = new String[1];
		resultNames[0] = "Result";
	}
	/**
	 * @return Returns the kernel.
	 */
	public float[] getKernel() {
		return kernel.getMatrixValue();
	}
	/**
	 * @param kernel The kernel to set.
	 */
	public void setKernel(String aKernel) {
		this.kernel.setValue(aKernel);
	}
	
	public void doIt() {
		convolver = null;
		ImagePlus inputImage = this.getInputImage();
		result = this.getCopyOfOrReferenceTo(inputImage, inputImage.getTitle());
		this.processSlices();
	}

	/**
	 * @return
	 */
	private int getKernelHeight() {
		return kernel.height();
	}

	/**
	 * @return
	 */
	private int getKernelWidth() {
		return kernel.width();
	}
	
	protected void setupOptions() {
		options = new Options(); 
		options.setName(this.name() + " options");
		String[] optionsNames = this.getOptionsNames();
		this.kernel = new MatrixOption();
		this.setKernel("-1, -1, -1, -1, -1;	-1, -1, -1, -1, -1; -1, -1, 24, -1, -1; -1, -1, -1, -1, -1; -1, -1, -1, -1, -1");
		kernel.setShortHelpText("enter a matrix. Use ';' to separate rows and ',' to separate values in a row");
		this.kernel.setName(optionsNames[0]);
		options.add(this.kernel);
		this.normalize = new BooleanOption();
		normalize.setValue("false");
		normalize.setName(optionsNames[1]);
		normalize.setShortHelpText("normalize the values to preserve the image brightness");
		options.add(normalize);
	}
	
	public void connectOptions() {
		this.kernel= (MatrixOption) this.options.getOptions().elementAt(0);
		this.normalize = (BooleanOption) this.options.getOptions().elementAt(1);
	}
	
	protected void doItForSlice(int sliceNumber, ImageStack stack) {
		ImageProcessor ip = stack.getProcessor(sliceNumber);
		this.getConvolver().convolve(ip, this.getKernel(), this.getKernelWidth(), this.getKernelHeight());
	}

	/**
	 * @return
	 */
	protected Convolver getConvolver() {
		if (convolver == null) {
			convolver = new Convolver();
			convolver.setNormalize(normalize.getBooleanValue());
		}
		return convolver;
	}
}
