package stackRegistration;

import java.awt.image.ColorModel;
import java.util.Observable;

public class ImageDisplayOptions extends Observable {
	protected float alpha = 1.0f;
	protected  ColorModel colorModel = null;
	protected ImageDisplayOptionsView view;
	
	public ImageDisplayOptions() {
		super();
		// TODO Auto-generated constructor stub
	}

	public float getAlpha() {
		return alpha;
	}

	public void setAlpha(float alpha) {
		this.alpha = alpha;
		this.changed("alpha");
	}

	public int getAlphaAsInt() {
		int result = Math.round(100 * alpha);
		return result;
	}
	
	protected ImageDisplayOptionsView getView() {
		if (view==null) view = new ImageDisplayOptionsView(this);
		return view;
	}
	
	public void show() {
		this.getView().setVisible(true);
	}
	
	private void changed(String string) {
		this.setChanged();
		this.notifyObservers(string);
		this.clearChanged();
	}

	public ColorModel getColorModel() {
		return colorModel;
	}

	public void setColorModel(ColorModel colorModel) {
		this.colorModel = colorModel;
	}
}
