package utils;

import ij.ImagePlus;
import ij.ImageStack;
import ij.plugin.filter.Duplicater;
import ij.process.ImageProcessor;

public class ImageDuplicater {
	static public ImagePlus copyImage(ImagePlus anImage, String title) {
		ImagePlus result = null;
		Duplicater copyAction = new Duplicater();
		result = copyAction.duplicateStack(anImage, title);
		if (result.getNSlices()==1) result.setImage(result.getProcessor().createImage());
		return result;
	}
	
	static public ImagePlus copyCurrentSlice(ImagePlus anImage, String title) {
		ImagePlus result = null;
		ImageStack stack = anImage.getStack();
		ImageProcessor ip2 = stack.getProcessor(anImage.getCurrentSlice()).crop();
		result = anImage.createImagePlus();
		result.setProcessor(title, ip2);
		String info = (String)anImage.getProperty("Info"); 
		int stackSize = stack.getSize();
		if (info!=null)
			result.setProperty("Info", info);
		if (stackSize>1) {
			String label = stack.getSliceLabel(anImage.getCurrentSlice());
			if (label!=null && label.indexOf('\n')>0)
				result.setProperty("Info", label);
		}
		return result;
	}
}
